Index: src/Actions/AtomAction/TranslateAction.def
===================================================================
--- src/Actions/AtomAction/TranslateAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AtomAction/TranslateAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,12 +10,17 @@
 #include "LinearAlgebra/Vector.hpp"
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (Vector)(bool)
 #define paramtokens ("translate-atoms")("periodic")
 #define paramdescriptions ("translation vector")("system is constraint to periodic boundary conditions")
 #define paramreferences (x)(periodic)
-#define paramdefaults (NODEFAULT)("0")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(false))
+#define paramvalids \
+(DummyValidator< Vector >()) \
+(DummyValidator< bool >())
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/CommandAction/BondLengthTableAction.cpp
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/BondLengthTableAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -43,5 +43,5 @@
   ostringstream usage;
 
-  LOG(0, "Using " << params.BondGraphFileName << " as bond length table.");
+  LOG(0, "Using " << params.BondGraphFileName.get() << " as bond length table.");
   BondGraph *&BG = World::getInstance().getBondGraph();
 
@@ -57,7 +57,7 @@
 
   BG->CleanupBondLengthTable();
-  if ((!params.BondGraphFileName.empty())
-      && boost::filesystem::exists(params.BondGraphFileName)) {
-    std::ifstream input(params.BondGraphFileName.string().c_str());
+  if ((!params.BondGraphFileName.get().empty())
+      && boost::filesystem::exists(params.BondGraphFileName.get())) {
+    std::ifstream input(params.BondGraphFileName.get().string().c_str());
     if ((input.good()) && (BG->LoadBondLengthTable(input))) {
       LOG(0, "Bond length table parsed successfully.");
@@ -96,5 +96,5 @@
   BondGraph *&BG = World::getInstance().getBondGraph();
   BG->CleanupBondLengthTable();
-  std::ifstream input(state->params.BondGraphFileName.string().c_str());
+  std::ifstream input(state->params.BondGraphFileName.get().string().c_str());
   if ((input.good()) && (BG->LoadBondLengthTable(input))) {
     LOG(0, "Bond length table parsed successfully.");
Index: src/Actions/CommandAction/BondLengthTableAction.def
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/BondLengthTableAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,9 @@
 #include "Graph/BondGraph.hpp"
 
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)
 #define paramtokens ("bond-table")
@@ -18,4 +20,6 @@
 #undef paramdefaults
 #define paramreferences (BondGraphFileName)
+#define paramvalids \
+(FilePresentValidator())
 
 #define statetypes (std::string)
Index: src/Actions/CommandAction/ElementDbAction.cpp
===================================================================
--- src/Actions/CommandAction/ElementDbAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/ElementDbAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -60,5 +60,5 @@
   // TODO: Make databasepath a std::string
   config *configuration = World::getInstance().getConfig();
-  strcpy(configuration->databasepath, params.databasepath.branch_path().string().c_str());
+  strcpy(configuration->databasepath, params.databasepath.get().branch_path().string().c_str());
 
   // load table
@@ -96,5 +96,5 @@
   // TODO: Make databasepath a std::string
   config *configuration = World::getInstance().getConfig();
-  strcpy(configuration->databasepath, state->params.databasepath.branch_path().string().c_str());
+  strcpy(configuration->databasepath, state->params.databasepath.get().branch_path().string().c_str());
 
   // load table
Index: src/Actions/CommandAction/ElementDbAction.def
===================================================================
--- src/Actions/CommandAction/ElementDbAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/ElementDbAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 #include <sstream>
 
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)
 #define paramtokens ("element-db")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (databasepath)
+#define paramvalids \
+(FilePresentValidator())
 
 #define statetypes (std::string)
Index: src/Actions/CommandAction/FastParsingAction.cpp
===================================================================
--- src/Actions/CommandAction/FastParsingAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/FastParsingAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,5 +40,5 @@
   bool oldvalue = configuration->FastParsing;
 
-  configuration->FastParsing = params.fastparsing;
+  configuration->FastParsing = params.fastparsing.get();
   if (configuration->FastParsing)
     LOG(0, "I won't parse trajectories.");
@@ -65,5 +65,5 @@
 
   config *configuration = World::getInstance().getConfig();
-  configuration->FastParsing = state->params.fastparsing;
+  configuration->FastParsing = state->params.fastparsing.get();
   if (configuration->FastParsing)
     LOG(0, "I won't parse trajectories.");
Index: src/Actions/CommandAction/FastParsingAction.def
===================================================================
--- src/Actions/CommandAction/FastParsingAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/FastParsingAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (bool)
 #define paramtokens ("fastparsing")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (fastparsing)
+#define paramvalids \
+(DummyValidator< bool >())
 
 #define statetypes (bool)
Index: src/Actions/CommandAction/HelpAction.cpp
===================================================================
--- src/Actions/CommandAction/HelpAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/HelpAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -63,5 +63,5 @@
   std::cout << std::endl;
   // print list of actions or its options
-  if (params.actionname == "none") {
+  if (params.actionname.get() == std::string("none")) {
     // print list of all Actions
     std::cout << "Here is a list of all available Actions:" << std::endl;
@@ -75,6 +75,6 @@
   } else {
     // retrieve command from Registry and print its help
-    if (ActionRegistry::getInstance().isActionPresentByName(params.actionname)) {
-      const Action *instance = ActionRegistry::getInstance().getActionByName(params.actionname);
+    if (ActionRegistry::getInstance().isActionPresentByName(params.actionname.get())) {
+      const Action *instance = ActionRegistry::getInstance().getActionByName(params.actionname.get());
       // else give description of Action and its option value if present
       std::cout << instance->help();
@@ -82,5 +82,5 @@
       std::cout << std::endl;
     } else {
-      ELOG(1, "No action is known by the name " << params.actionname << ".");
+      ELOG(1, "No action is known by the name " << params.actionname.get() << ".");
       return Action::failure;
     }
Index: src/Actions/CommandAction/HelpAction.def
===================================================================
--- src/Actions/CommandAction/HelpAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/HelpAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,14 +7,24 @@
 
 // all includes and forward declarations necessary for non-integral types below
+#include <string> 
+#include <vector> 
 
+#include "Parameters/Validators/DiscreteValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/ActionNameValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("actionname")
 #define paramdescriptions ("Name of an action whose option list is then given")
-#define paramdefaults ("none")
+#define paramdefaults (PARAM_DEFAULT(std::string("none")))
 #define paramreferences (actionname)
+#define paramvalids \
+(DiscreteValidator<std::string>(std::vector<std::string>(1, std::string("none"))) || ActionNameValidator())
+// NOTE: The _default_ value MUST NOT require validation via ActionNameValidator!
+// This will trigger an infinite loop of ActionRegistry::fillRegistry() calls as ActionRegistry is
+// at the time of the filling on of the default values not yet completely constructed!
 
 #undef statetypes
Index: src/Actions/CommandAction/VerboseAction.cpp
===================================================================
--- src/Actions/CommandAction/VerboseAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/VerboseAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -35,12 +35,12 @@
 /** =========== define the function ====================== */
 Action::state_ptr CommandVerboseAction::performCall() {
-  int oldverbosity = getVerbosity();
+  unsigned int oldverbosity = getVerbosity();
 
-  if (oldverbosity != params.verbosity) {
+  if (oldverbosity != params.verbosity.get()) {
     // prepare undo state
     CommandVerboseState *UndoState = new CommandVerboseState(oldverbosity, params);
     // set new verbosity
-    setVerbosity(params.verbosity);
-    LOG(0, "Setting verbosity from " << oldverbosity << " to " << params.verbosity << ".");
+    setVerbosity(params.verbosity.get());
+    LOG(0, "Setting verbosity from " << oldverbosity << " to " << params.verbosity.get() << ".");
     return Action::state_ptr(UndoState);
   } else {
@@ -53,5 +53,5 @@
   CommandVerboseState *state = assert_cast<CommandVerboseState*>(_state.get());
 
-  LOG(0, "Setting verbosity from " << state->params.verbosity << " to " << state->oldverbosity << ".");
+  LOG(0, "Setting verbosity from " << state->params.verbosity.get() << " to " << state->oldverbosity << ".");
   setVerbosity(state->oldverbosity);
 
@@ -62,6 +62,6 @@
   CommandVerboseState *state = assert_cast<CommandVerboseState*>(_state.get());
 
-  LOG(0, "Setting verbosity from " << state->oldverbosity << " to " << state->params.verbosity << ".");
-  setVerbosity(state->params.verbosity);
+  LOG(0, "Setting verbosity from " << state->oldverbosity << " to " << state->params.verbosity.get() << ".");
+  setVerbosity(state->params.verbosity.get());
 
   return Action::state_ptr(_state);
Index: src/Actions/CommandAction/VerboseAction.def
===================================================================
--- src/Actions/CommandAction/VerboseAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/VerboseAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,14 +9,18 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (int)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (unsigned int)
 #define paramtokens ("verbose")
 #define paramdescriptions ("set verbosity level")
 #undef paramdefaults
 #define paramreferences (verbosity)
+#define paramvalids \
+(DummyValidator< unsigned int >())
 
-#define statetypes (int)
+#define statetypes (unsigned int)
 #define statereferences (oldverbosity)
 
Index: src/Actions/CommandAction/VersionAction.def
===================================================================
--- src/Actions/CommandAction/VersionAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/VersionAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 #include "version.h"
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #undef statetypes
Index: src/Actions/CommandAction/WarrantyAction.def
===================================================================
--- src/Actions/CommandAction/WarrantyAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/CommandAction/WarrantyAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #undef statetypes
Index: src/Actions/FillAction/FillRegularGridAction.cpp
===================================================================
--- src/Actions/FillAction/FillRegularGridAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FillAction/FillRegularGridAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -82,7 +82,7 @@
   LinkedCell_deprecated * LC = NULL;
   Tesselation * TesselStruct = NULL;
-  if (params.SphereRadius != 0.) {
+  if (params.SphereRadius.get() != 0.) {
     if ( atoms.size() == 0) {
-      ELOG(1, "You have given a sphere radius " << params.SphereRadius
+      ELOG(1, "You have given a sphere radius " << params.SphereRadius.get()
           << " != 0, but have not select any molecules.");
       return Action::failure;
@@ -92,7 +92,7 @@
 
     // create tesselation
-    LC = new LinkedCell_deprecated(cloud, 2.*params.SphereRadius);
+    LC = new LinkedCell_deprecated(cloud, 2.*params.SphereRadius.get());
     TesselStruct = new Tesselation;
-    (*TesselStruct)(cloud, params.SphereRadius);
+    (*TesselStruct)(cloud, params.SphereRadius.get());
 
     // and create predicate
@@ -106,5 +106,5 @@
     FillPredicate *voidnode_predicate = new FillPredicate(
         IsVoidNode_FillPredicate(
-            Sphere(zeroVec, params.mindistance)
+            Sphere(zeroVec, params.mindistance.get())
             )
         );
@@ -112,11 +112,11 @@
     if (surface_predicate != NULL)
       Andpredicate = (Andpredicate) && !(*surface_predicate);
-    Mesh *mesh = new CubeMesh(params.counts, params.offset, World::getInstance().getDomain().getM());
+    Mesh *mesh = new CubeMesh(params.counts.get(), params.offset.get(), World::getInstance().getDomain().getM());
     Inserter *inserter = new Inserter(
         Inserter::impl_ptr(
             new RandomInserter(
-                params.RandAtomDisplacement,
-                params.RandMoleculeDisplacement,
-                params.DoRotate)
+                params.RandAtomDisplacement.get(),
+                params.RandMoleculeDisplacement.get(),
+                params.DoRotate.get())
             )
         );
Index: src/Actions/FillAction/FillRegularGridAction.def
===================================================================
--- src/Actions/FillAction/FillRegularGridAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FillAction/FillRegularGridAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -12,12 +12,26 @@
 #include "types.hpp"
 
+#include "LinearAlgebra/defs.hpp"
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/VectorZeroOneComponentsValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (Vector)(Vector)(double)(double)(double)(double)(bool)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::vector< unsigned int >)(Vector)(double)(double)(double)(double)(bool)
 #define paramtokens ("mesh-size")("mesh-offset")("min-distance")("tesselation-radius")("random-atom-displacement")("random-molecule-displacement")("DoRotate")
 #define paramdescriptions ("number of points per axis")("offset to start of partition, must be in [0,1)")("Minimum distance to other atoms")("radius of rolling sphere in tesselating selected molecule's surfaces")("magnitude of random atom displacement")("magnitude of random molecule displacement")("whether to rotate or not")
-#define paramdefaults (NODEFAULT)("0.,0.,0.")("1.")("0.")("0.")("0.")("0")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(Vector(0.,0.,0.)))(PARAM_DEFAULT(1.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(false))
 #define paramreferences (counts)(offset)(mindistance)(SphereRadius)(RandAtomDisplacement)(RandMoleculeDisplacement)(DoRotate)
+#define paramvalids \
+(STLVectorValidator< std::vector< unsigned int > >(NDIM, NDIM)) \
+(VectorZeroOneComponentsValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(DummyValidator< bool >())
 
 #define statetypes (std::vector<AtomicInfo>)(std::vector<BondInfo>)(std::vector<AtomicInfo>)(std::vector<Vector>)
Index: src/Actions/FillAction/FillSphericalSurfaceAction.cpp
===================================================================
--- src/Actions/FillAction/FillSphericalSurfaceAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FillAction/FillSphericalSurfaceAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -71,5 +71,5 @@
   Vector sum = zeroVec;
   for (molecule::iterator it2=filler->begin();it2 !=filler->end();++it2) {
-    const Vector helper = (**it2).getPosition().partition(params.AlignedAxis).second;
+    const Vector helper = (**it2).getPosition().partition(params.AlignedAxis.get()).second;
     sum += helper;
   }
@@ -89,13 +89,13 @@
     FillPredicate *voidnode_predicate = new FillPredicate(
         IsVoidNode_FillPredicate(
-            Sphere(zeroVec, params.mindistance)
+            Sphere(zeroVec, params.mindistance.get())
             )
         );
-    Shape s = Sphere(params.center, params.radius);
+    Shape s = Sphere(params.center.get(), params.radius.get());
     boost::function<const NodeSet ()> func = 
-        boost::bind(&Shape::getHomogeneousPointsOnSurface, boost::ref(s), params.N);
+        boost::bind(&Shape::getHomogeneousPointsOnSurface, boost::ref(s), params.N.get());
     Mesh *mesh = new MeshAdaptor(func);
     Inserter *inserter = new Inserter(
-        Inserter::impl_ptr(new SurfaceInserter(s, params.AlignedAxis)));
+        Inserter::impl_ptr(new SurfaceInserter(s, params.AlignedAxis.get())));
 
     // fill
Index: src/Actions/FillAction/FillSphericalSurfaceAction.def
===================================================================
--- src/Actions/FillAction/FillSphericalSurfaceAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FillAction/FillSphericalSurfaceAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -12,12 +12,22 @@
 #include "types.hpp"
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (Vector)(double)(int)(double)(Vector)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (Vector)(double)(unsigned int)(double)(Vector)
 #define paramtokens ("center")("radius")("count")("min-distance")("Alignment-Axis")
 #define paramdescriptions ("center of the sphere")("sphere size")("number of instances to be added, changed according to geometric needs")("minimum distance between added instances")("The filler molecule is rotated relative to this alignment axis")
-#define paramdefaults ("0.,0.,0.")(NODEFAULT)("12")("1.")(NODEFAULT)
+#define paramdefaults (PARAM_DEFAULT(Vector(0.,0.,0.)))(NOPARAM_DEFAULT)(PARAM_DEFAULT(12))(PARAM_DEFAULT(1.))(NOPARAM_DEFAULT)
 #define paramreferences (center)(radius)(N)(mindistance)(AlignedAxis)
+#define paramvalids \
+(BoxVectorValidator()) \
+(BoxLengthValidator()) \
+(DummyValidator< unsigned int >()) \
+(BoxLengthValidator()) \
+(DummyValidator< Vector >())
 
 #define statetypes (std::vector<AtomicInfo>)(std::vector<BondInfo>)(std::vector<AtomicInfo>)(std::vector<Vector>)
Index: src/Actions/FragmentationAction/FragmentationAction.cpp
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FragmentationAction/FragmentationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -45,8 +45,8 @@
 
   LOG(0, "STATUS: Fragmenting molecular system with current connection matrix maximum bond distance "
-      << params.distance << " up to "
-      << params.order << " order. Fragment files begin with "
-      << params.prefix << " and are stored as: "
-      << params.types << "." << std::endl);
+      << params.distance.get() << " up to "
+      << params.order.get() << " order. Fragment files begin with "
+      << params.prefix.get() << " and are stored as: "
+      << params.types.get() << "." << std::endl);
 
   DepthFirstSearchAnalysis DFS;
@@ -54,10 +54,10 @@
     mol = iter->second;
     ASSERT(mol != NULL, "No molecule has been picked for fragmentation.");
-    LOG(2, "INFO: Fragmenting molecule with bond distance " << params.distance << " angstroem, order of " << params.order << ".");
+    LOG(2, "INFO: Fragmenting molecule with bond distance " << params.distance.get() << " angstroem, order of " << params.order.get() << ".");
     start = clock();
     if (mol->hasBondStructure()) {
-      Fragmentation Fragmenter(mol, params.DoSaturation ? DoSaturate : DontSaturate);
-      Fragmenter.setOutputTypes(params.types);
-      ExitFlag = Fragmenter.FragmentMolecule(params.order, params.prefix, DFS);
+      Fragmentation Fragmenter(mol, params.DoSaturation.get() ? DoSaturate : DontSaturate);
+      Fragmenter.setOutputTypes(params.types.get());
+      ExitFlag = Fragmenter.FragmentMolecule(params.order.get(), params.prefix.get(), DFS);
     }
     World::getInstance().setExitFlag(ExitFlag);
Index: src/Actions/FragmentationAction/FragmentationAction.def
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FragmentationAction/FragmentationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,15 +7,28 @@
 
 // all includes and forward declarations necessary for non-integral types below
+#include <boost/assign.hpp> 
 #include <string>
 #include <vector>
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/GenericValidators.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/ParserTypeValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::string)(double)(int)(bool)(std::vector<std::string>)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::string)(double)(unsigned int)(bool)(std::vector<std::string>)
 #define paramtokens ("fragment-molecule")("distance")("order")("DoSaturate")("output-types")
 #define paramdescriptions ("prefix of each fragment file")("distance in space")("order of a discretization, dissection, ...")("do saturate dangling bonds with hydrogen")("type(s) of parsers that output fragment config files")
-#define paramdefaults (NODEFAULT)(NODEFAULT)(NODEFAULT)("1")("pcp tremolo xyz")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(true)) (PARAM_DEFAULT(std::vector<std::string>(1, std::string("pcp"))))
 #define paramreferences (prefix)(distance)(order)(DoSaturation)(types)
+#define paramvalids \
+(DummyValidator< std::string >()) \
+(BoxLengthValidator()) \
+(DummyValidator< unsigned int >()) \
+(DummyValidator< bool >()) \
+(STLVectorValidator< std::vector<std::string> >(1, 10, ParserTypeValidator()))
 
 #undef statetypes
Index: src/Actions/FragmentationAction/FragmentationAutomationAction.cpp
===================================================================
--- src/Actions/FragmentationAction/FragmentationAutomationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FragmentationAction/FragmentationAutomationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -267,5 +267,6 @@
 
   // Phase One: obtain ids
-  controller.requestIds(params.host, params.port, params.jobfiles.size());
+  std::vector< boost::filesystem::path > jobfiles = params.jobfiles.get();
+  controller.requestIds(params.host.get(), params.port.get(), jobfiles.size());
   {
     io_service.reset();
@@ -276,6 +277,6 @@
   {
     std::vector<FragmentJob::ptr> jobs;
-    for (std::vector< boost::filesystem::path >::const_iterator iter = params.jobfiles.begin();
-        iter != params.jobfiles.end(); ++iter) {
+    for (std::vector< boost::filesystem::path >::const_iterator iter = jobfiles .begin();
+        iter != jobfiles .end(); ++iter) {
       const std::string &filename = (*iter).string();
       if (boost::filesystem::exists(filename)) {
@@ -283,5 +284,5 @@
         LOG(1, "INFO: Creating MPQCCommandJob with filename'"
             +filename+"', and id "+toString(next_id)+".");
-        parsejob(jobs, params.executable.string(), filename, next_id);
+        parsejob(jobs, params.executable.get().string(), filename, next_id);
       } else {
         ELOG(1, "Fragment job "+filename+" does not exist.");
@@ -290,5 +291,5 @@
     }
     controller.addJobs(jobs);
-    controller.sendJobs(params.host, params.port);
+    controller.sendJobs(params.host.get(), params.port.get());
   }
   {
@@ -299,5 +300,5 @@
   // Phase Three: calculate result
   size_t NoCalculatedResults = 0;
-  while (NoCalculatedResults != params.jobfiles.size()) {
+  while (NoCalculatedResults != jobfiles.size()) {
     // wait a bit
     boost::asio::deadline_timer timer(io_service);
@@ -305,5 +306,5 @@
     timer.wait();
     // then request status
-    controller.checkResults(params.host, params.port);
+    controller.checkResults(params.host.get(), params.port.get());
     {
       io_service.reset();
@@ -316,5 +317,5 @@
   }
   // Phase Three: get result
-  controller.receiveResults(params.host, params.port);
+  controller.receiveResults(params.host.get(), params.port.get());
   {
     io_service.reset();
@@ -324,10 +325,10 @@
   // Final phase: print result
   {
-    LOG(1, "INFO: Parsing fragment files from " << params.path << ".");
+    LOG(1, "INFO: Parsing fragment files from " << params.path.get() << ".");
     std::vector<FragmentResult::ptr> results = controller.getReceivedResults();
     printReceivedMPQCResults(
         results,
-        params.path,
-        getNoAtomsFromAdjacencyFile(params.path));
+        params.path.get(),
+        getNoAtomsFromAdjacencyFile(params.path.get()));
   }
   size_t Exitflag = controller.getExitflag();
